#!/bin/sh

if test -z "$with_cc"
then
	if ! test -z "$with_target_dir"
	then
		with_cc="${with_target}gcc"
	fi
fi

if test -z "$with_ld"
then
	with_ld="${with_target}ld"
fi

if test -z "$with_strip"
then
	with_strip="${with_target}strip"
fi

if test -z "$with_fs_ln"
then
	with_fs_ln="cp -R"
fi

if test -z "$with_sys_cflags"
then
	with_sys_cflags="-DWINDLL -Wall"
fi

if test -z "$with_sys_ldflags_static"
then
	with_sys_ldflags_static="-shared"
fi

if test -z "$with_sys_ldflags_dynamic"
then
	with_sys_ldflags_dynamic="-dynamic -shared"
fi

if test -z "$with_sys_libext_static"
then
	with_sys_libext_static=".a"
fi

if test -z "$with_sys_libext_dynamic"
then
	with_sys_libext_dynamic=".dll"
fi

if test -z "$with_sys_archive_objs"
then
	with_sys_archive_objs="-Wl,-whole-archive \$(ARCHIVES) -Wl,-no-whole-archive"
fi

if test -z "$with_sys_libext_exe"
then
	with_sys_libext_exe=".exe"
fi

if test -z "$with_sys_libext_fnprefix"
then
	with_sys_libext_fnprefix="\$(DLL_PREFIX)"
fi

if test -z "$with_dll_dep"
then
	with_dll_dep="../../gpmi/libgpmi.dll"
fi

if test -z "$with_sys_lpthread"
then
	with_sys_lpthread="-lpthreadGC2"
fi

export with_os=windows
