/**
 * @file keyword_hash.h
 * \brief Helper to hash keywords.
 *
 * Helper that hashes keywords and help to find them back.
 */

#ifndef GPMI_KEYWORD_HASH_H
#define GPMI_KEYWORD_HASH_H

unsigned int gpmi_hash_int_static(int cmd, void *data1, void *data2, char **result_pointer);
unsigned int gpmi_hash_int_dynamic(int cmd, void *data1, void *data2, char **result_pointer);
unsigned int gpmi_hash_str_dynamic(int cmd, void *data1, void *data2, char **result_pointer);
unsigned int gpmi_hash_ptr(int cmd, void *data1, void *data2, char **result_pointer);
unsigned int gpmi_hash_int_rev(int cmd, void *data1, void *data2, char **result_pointer);
unsigned int gpmi_hash_ptr_rev(int cmd, void *data1, void *data2, char **result_pointer);

#endif /* GPMI_KEYWORD_HASH_H */
