# This is an example how to use python with gpmi. This script is also part of
# the regression test

def RunData(data):
	print "main:RunData " + data + " == 0x1234"

def ev_cycle(timer_data):
	global gTTL, gfreq

	TTL = TimerInfo(timer_data, "TTL");
	freq = TimerInfo(timer_data, "freq");
	user_data = TimerInfo(timer_data, "user_data");
	
	print "main:ev_cycle ( " + str(gTTL) + " == " + TTL + " )  ( " + str(gfreq) + " == " + freq + " ) ( " + user_data + " == data1 ) (runs 4 times)"
	gTTL -= 1

def ev_every_second(timer_data):
	global gTTL, gfreq

        TTL = TimerInfo(timer_data, "TTL");
	freq = TimerInfo(timer_data, "freq");
	user_data = TimerInfo(timer_data, "user_data");		
	
	print "main:ev_every_second ( " + str(gTTL) + " == " + TTL + " )  ( " + str(gfreq) + " == " + freq + " ) ( " + user_data + " == data2 ) (runs 3 times)"
	gTTL -= 1

def ev_nothing(id, year, param):
	print "main:ev_nothing: year: ( " + str(gyear) + " == " + year + " ) param: ( " + str(gparam) + " == " + param + " )"

def run_once(timer_data):
	global gTTL, gfreq, gyear, gparam
	
	print "main:Running init part."

	# Check timers
	gTTL = 4
	gfreq = 0
	AddTimer(4, 0, "ev_cycle", "data1")
	gTTL = 3
	gfreq = 2
	AddTimer(3, 2, "ev_every_second", "data2")

	# Check package loading
	PkgLoad("example", 0)
	print "main:main1 " + Example_int(10) + " == 1244 when works"

	# Check events
	gyear = 2005
	gparam = 155
	Bind("Example_nothing", "ev_nothing")
	Example_do_nothing(155)

	# Check FakeEvent
	gyear = 3000
	gparam = 20
	FakeEvent("Example_nothing", "3000 20")

	print "main:main2 Finished init part."

AddTimer("1", "1", "run_once", "");
