/* A Bison parser, made by GNU Bison 1.875d.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 1

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse yylgparse
#define yylex   yylglex
#define yyerror yylgerror
#define yylval  yylglval
#define yychar  yylgchar
#define yydebug yylgdebug
#define yynerrs yylgnerrs
#define yylloc yylglloc

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     ID = 258,
     NUMBER = 259,
     ENUM = 260,
     CMT_OPEN = 261,
     CMT_CLOSE = 262,
     UNSIGNED = 263,
     INT = 264,
     DOUBLE = 265,
     CHAR = 266,
     VOID = 267,
     EVENT = 268,
     TYPEDEF = 269,
     GPMI_KEYWORD = 270,
     GPMI_FAKE_KEYWORD = 271,
     GPMI_DEFINE_EVENT = 272,
     OF = 273,
     MULTIPLE = 274,
     DYNAMIC = 275,
     CONST = 276,
     STRUCT = 277,
     FAKETYPE = 278,
     EXTERN = 279,
     UNION = 280,
     DIRECT = 281,
     NOWRAP = 282,
     INLINE = 283
   };
#endif
#define ID 258
#define NUMBER 259
#define ENUM 260
#define CMT_OPEN 261
#define CMT_CLOSE 262
#define UNSIGNED 263
#define INT 264
#define DOUBLE 265
#define CHAR 266
#define VOID 267
#define EVENT 268
#define TYPEDEF 269
#define GPMI_KEYWORD 270
#define GPMI_FAKE_KEYWORD 271
#define GPMI_DEFINE_EVENT 272
#define OF 273
#define MULTIPLE 274
#define DYNAMIC 275
#define CONST 276
#define STRUCT 277
#define FAKETYPE 278
#define EXTERN 279
#define UNION 280
#define DIRECT 281
#define NOWRAP 282
#define INLINE 283




/* Copy the first part of user declarations.  */
#line 1 "listgen.y"

	#include <stdlib.h>
	#include <stdio.h>
	#include <string.h>
	#include "listgen1.h"


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 8 "listgen.y"
typedef union YYSTYPE {
	int num;
	char *str;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 153 "listgen.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined (YYLTYPE) && ! defined (YYLTYPE_IS_DECLARED)
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 177 "listgen.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYLTYPE_IS_TRIVIAL) && YYLTYPE_IS_TRIVIAL \
             && defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
    YYLTYPE yyls;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   423

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  49
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  36
/* YYNRULES -- Number of rules. */
#define YYNRULES  144
/* YYNRULES -- Number of states. */
#define YYNSTATES  317

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   283

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    39,     2,     2,     2,     2,    48,     2,
      32,    33,    44,    46,    34,    47,    38,    35,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    37,    31,
      40,    45,    41,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    42,     2,    43,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    29,    36,    30,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     7,     9,    11,    13,    15,    17,
      19,    23,    25,    27,    29,    36,    41,    42,    51,    59,
      60,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   138,
     148,   149,   160,   161,   164,   167,   172,   176,   177,   180,
     183,   186,   189,   192,   195,   199,   203,   206,   209,   212,
     215,   218,   221,   222,   230,   231,   242,   257,   273,   281,
     292,   301,   313,   314,   324,   325,   328,   329,   331,   333,
     336,   341,   345,   354,   365,   368,   371,   373,   375,   380,
     386,   392,   394,   397,   400,   402,   405,   408,   412,   414,
     417,   419,   422,   425,   429,   431,   434,   436,   439,   448,
     455,   459,   462,   463,   475,   477,   481,   483,   487,   492,
     497,   498,   508,   509,   517
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      50,     0,    -1,    -1,    50,    51,    -1,    58,    -1,    64,
      -1,    55,    -1,    67,    -1,    77,    -1,    53,    -1,     6,
      56,     7,    -1,    82,    -1,    78,    -1,    52,    -1,    25,
      29,    50,    30,    81,    31,    -1,    14,    73,     3,    31,
      -1,    -1,    14,    73,     3,    32,    54,    71,    33,    31,
      -1,    23,    32,    74,    34,     3,    33,    31,    -1,    -1,
      57,    56,    -1,     3,    -1,     5,    -1,    13,    -1,    14,
      -1,    15,    -1,    17,    -1,    24,    -1,    18,    -1,    35,
      -1,    36,    -1,    37,    -1,    31,    -1,    29,    -1,    30,
      -1,    34,    -1,    32,    -1,    33,    -1,    38,    -1,    39,
      -1,    40,    -1,    41,    -1,    42,    -1,    43,    -1,    25,
      -1,    19,    -1,     4,    -1,    22,    -1,     9,    -1,     8,
      -1,    10,    -1,    12,    -1,    21,    -1,    11,    -1,    20,
      -1,    26,    -1,    27,    -1,    44,    -1,    -1,    14,     5,
       3,    29,    59,    61,    30,     3,    31,    -1,    -1,    27,
      14,     5,     3,    29,    60,    61,    30,     3,    31,    -1,
      -1,    61,    62,    -1,     3,    34,    -1,     3,    45,    63,
      34,    -1,     6,    56,     7,    -1,    -1,    44,    63,    -1,
      35,    63,    -1,    46,    63,    -1,    47,    63,    -1,    36,
      63,    -1,    48,    63,    -1,    45,    45,    63,    -1,    39,
      45,    63,    -1,    40,    63,    -1,    41,    63,    -1,    32,
      63,    -1,    33,    63,    -1,     4,    63,    -1,     3,    63,
      -1,    -1,    73,     3,    32,    65,    71,    33,    31,    -1,
      -1,    73,    32,    76,     3,    33,    32,    66,    71,    33,
      31,    -1,    26,    11,    44,     3,    32,     9,     3,    34,
      11,    44,    44,     3,    33,    31,    -1,    26,    11,    44,
       3,    32,     9,     3,    34,    11,    44,     3,    42,    43,
      33,    31,    -1,    27,    73,     3,    32,    71,    33,    31,
      -1,    27,    73,    32,    76,     3,    33,    32,    71,    33,
      31,    -1,    27,    28,    73,     3,    32,    71,    33,    31,
      -1,    27,    28,    73,    32,    76,     3,    33,    32,    71,
      33,    31,    -1,    -1,    17,    32,     3,    33,    32,    68,
      72,    33,    31,    -1,    -1,    70,    71,    -1,    -1,    72,
      -1,    12,    -1,    73,     3,    -1,    73,     3,    34,    72,
      -1,    38,    38,    38,    -1,    73,    32,    76,     3,    33,
      32,    69,    33,    -1,    73,    32,    76,     3,    33,    32,
      69,    33,    34,    72,    -1,    20,    74,    -1,    21,    74,
      -1,    74,    -1,    75,    -1,     9,     6,     3,     7,    -1,
       8,     9,     6,     3,     7,    -1,     8,    11,     6,     3,
       7,    -1,     3,    -1,     3,    76,    -1,    19,     3,    -1,
       9,    -1,     9,    76,    -1,     8,     9,    -1,     8,     9,
      76,    -1,    10,    -1,    10,    76,    -1,    11,    -1,    11,
      76,    -1,     8,    11,    -1,     8,    11,    76,    -1,    12,
      -1,    12,    76,    -1,    44,    -1,    76,    44,    -1,    15,
      44,     3,    31,     6,    18,     3,     7,    -1,    16,    32,
      44,     3,    33,    31,    -1,    73,    80,    31,    -1,    24,
      78,    -1,    -1,    24,    74,    32,    76,    81,    33,    32,
      79,    71,    33,    31,    -1,    81,    -1,    81,    34,    80,
      -1,     3,    -1,     3,    42,    43,    -1,     3,    42,     3,
      43,    -1,     3,    42,     4,    43,    -1,    -1,    14,    22,
       3,    29,    83,    50,    30,     3,    31,    -1,    -1,    22,
       3,    29,    84,    50,    30,    31,    -1,    14,    22,     3,
       3,    31,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,    52,    52,    54,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    73,    77,    78,    78,    82,    85,
      87,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   131,   131,
     133,   133,   139,   140,   144,   145,   146,   149,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   168,   168,   174,   174,   180,   181,   182,   183,
     184,   185,   190,   190,   195,   195,   198,   200,   201,   205,
     206,   207,   208,   209,   214,   215,   216,   221,   222,   223,
     224,   225,   226,   227,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   246,   247,   252,   253,
     259,   260,   261,   261,   265,   266,   270,   271,   272,   273,
     277,   277,   278,   278,   279
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "ID", "NUMBER", "ENUM", "CMT_OPEN",
  "CMT_CLOSE", "UNSIGNED", "INT", "DOUBLE", "CHAR", "VOID", "EVENT",
  "TYPEDEF", "GPMI_KEYWORD", "GPMI_FAKE_KEYWORD", "GPMI_DEFINE_EVENT",
  "OF", "MULTIPLE", "DYNAMIC", "CONST", "STRUCT", "FAKETYPE", "EXTERN",
  "UNION", "DIRECT", "NOWRAP", "INLINE", "'{'", "'}'", "';'", "'('", "')'",
  "','", "'/'", "'|'", "':'", "'.'", "'!'", "'<'", "'>'", "'['", "']'",
  "'*'", "'='", "'+'", "'-'", "'&'", "$accept", "headers", "header",
  "union", "typedef", "@1", "faketype", "junks", "junk", "enum", "@2",
  "@3", "enum_list", "enum_element", "expr", "function", "@4", "@5",
  "event", "@6", "param_list_or_empty_drop", "@7", "param_list_or_empty",
  "param_list", "type", "type_", "type_standard", "ptr", "keyword_def",
  "vardef", "@8", "id_list", "id_list_member", "struct", "@9", "@10", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   123,
     125,    59,    40,    41,    44,    47,   124,    58,    46,    33,
      60,    62,    91,    93,    42,    61,    43,    45,    38
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    49,    50,    50,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    52,    53,    54,    53,    55,    56,
      56,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    57,    57,
      57,    57,    57,    57,    57,    57,    57,    57,    59,    58,
      60,    58,    61,    61,    62,    62,    62,    63,    63,    63,
      63,    63,    63,    63,    63,    63,    63,    63,    63,    63,
      63,    63,    65,    64,    66,    64,    64,    64,    64,    64,
      64,    64,    68,    67,    70,    69,    71,    71,    71,    72,
      72,    72,    72,    72,    73,    73,    73,    74,    74,    74,
      74,    74,    74,    74,    75,    75,    75,    75,    75,    75,
      75,    75,    75,    75,    75,    75,    76,    76,    77,    77,
      78,    78,    79,    78,    80,    80,    81,    81,    81,    81,
      83,    82,    84,    82,    82
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     6,     4,     0,     8,     7,     0,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     9,
       0,    10,     0,     2,     2,     4,     3,     0,     2,     2,
       2,     2,     2,     2,     3,     3,     2,     2,     2,     2,
       2,     2,     0,     7,     0,    10,    14,    15,     7,    10,
       8,    11,     0,     9,     0,     2,     0,     1,     1,     2,
       4,     3,     8,    10,     2,     2,     1,     1,     4,     5,
       5,     1,     2,     2,     1,     2,     2,     3,     1,     2,
       1,     2,     2,     3,     1,     2,     1,     2,     8,     6,
       3,     2,     0,    11,     1,     3,     1,     3,     4,     4,
       0,     9,     0,     7,     5
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     1,   111,    19,     0,   114,   118,   120,   124,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     3,    13,     9,     6,     4,     5,     7,
       0,   106,   107,     8,    12,    11,   126,   112,    21,    46,
      22,    49,    48,    50,    53,    51,    23,    24,    25,    26,
      28,    45,    54,    52,    47,    27,    44,    55,    56,    33,
      34,    32,    36,    37,    35,    29,    30,    31,    38,    39,
      40,    41,    42,    43,    57,     0,    19,   116,   122,     0,
     115,   119,   121,   125,     0,     0,     0,     0,     0,     0,
     113,   104,   105,     0,     0,     0,   106,   131,     2,     0,
       0,     0,     0,   136,     0,     0,   134,   127,    10,    20,
       0,   117,     0,   123,     0,     0,     0,     0,     0,     0,
       0,   142,     0,   136,     0,     0,     0,     0,     0,     0,
       0,    82,     0,     0,   130,     0,     0,     0,   108,    58,
       0,   140,    15,    16,     0,     0,     0,     2,     0,     0,
       0,     0,     0,     0,     0,    96,     0,    96,     0,     0,
     137,     0,   135,   109,   110,    62,   144,     2,    96,     0,
       0,    92,     0,     0,     0,     0,     0,    60,    96,     0,
     124,     0,     0,    97,     0,     0,     0,   138,   139,     0,
       0,     0,     0,     0,   129,     0,     0,     0,     0,    14,
       0,    62,     0,     0,     0,     0,    99,     0,     0,     0,
      84,     0,    19,     0,    63,     0,     0,     0,     0,   143,
      18,   132,     0,     0,     0,     0,   101,    88,     0,     0,
      96,    83,    96,    64,    67,     0,     0,     0,    17,   128,
       0,    96,     0,     0,    90,    96,   100,     0,     0,     0,
      67,    67,    67,    67,    67,    67,     0,    67,    67,    67,
       0,    67,    67,    67,     0,    66,    59,   141,    93,     0,
       0,     0,     0,     0,     0,     0,    81,    80,    78,    79,
      69,    72,    67,    76,    77,    68,    67,    70,    71,    73,
      65,     0,     0,    61,     0,    94,    89,    85,    75,    74,
     133,     0,     0,    91,     0,    96,     0,     0,   102,    95,
       0,     0,     0,     0,    86,   103,    87
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     1,    23,    24,    25,   168,    26,    75,    76,    27,
     165,   201,   190,   214,   264,    28,   157,   232,    29,   195,
     304,   305,   182,   183,   184,    31,    32,    83,    33,    34,
     241,   105,   106,    35,   167,   147
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -189
static const short int yypact[] =
{
    -189,   221,  -189,   -15,   176,    69,     4,   -15,   -15,   -15,
     355,   -11,     9,    52,    50,   158,   158,    83,    57,   335,
      64,    85,   321,  -189,  -189,  -189,  -189,  -189,  -189,  -189,
      29,  -189,  -189,  -189,  -189,  -189,  -189,    54,  -189,  -189,
    -189,  -189,  -189,  -189,  -189,  -189,  -189,  -189,  -189,  -189,
    -189,  -189,  -189,  -189,  -189,  -189,  -189,  -189,  -189,  -189,
    -189,  -189,  -189,  -189,  -189,  -189,  -189,  -189,  -189,  -189,
    -189,  -189,  -189,  -189,  -189,    90,   176,    10,    28,    96,
      54,    54,    54,    54,   110,   114,   115,   116,    76,   119,
    -189,  -189,  -189,    94,   158,   125,    97,  -189,  -189,    92,
     133,   370,    32,    53,   -15,   113,   118,  -189,  -189,  -189,
     147,    54,   150,    54,   148,   130,    80,    60,   131,   160,
     132,  -189,   138,   129,   -15,   246,   161,   171,    36,   144,
     -15,  -189,    27,    16,  -189,   125,   175,   192,  -189,  -189,
     152,  -189,  -189,  -189,   172,   189,   191,  -189,   222,    19,
     125,   194,   199,   202,   -15,   122,    21,   122,   196,   207,
    -189,   218,  -189,  -189,  -189,  -189,  -189,  -189,   122,   235,
     228,  -189,   271,   231,   242,   247,   275,  -189,   122,    22,
       5,   251,   267,  -189,    39,   270,   276,  -189,  -189,   282,
      15,   296,   292,   324,  -189,   137,   297,   303,   304,  -189,
     334,  -189,   306,   315,   312,   320,   318,   -15,   325,   322,
    -189,    43,   176,   358,  -189,   359,   337,   362,   338,  -189,
    -189,  -189,   336,    70,   341,   351,  -189,  -189,   137,    23,
     122,  -189,   122,  -189,    11,   377,   354,   356,  -189,  -189,
     357,   122,   375,   389,  -189,   122,  -189,   360,   361,   363,
      11,    11,    11,    11,    11,    11,   350,    11,    11,    11,
     352,    11,    11,    11,   364,  -189,  -189,  -189,  -189,   366,
     365,   369,   368,   371,   373,   374,  -189,  -189,  -189,  -189,
    -189,  -189,    11,  -189,  -189,  -189,    11,  -189,  -189,  -189,
    -189,   376,    25,  -189,   379,  -189,  -189,  -189,  -189,  -189,
    -189,   372,   399,  -189,   378,   122,   380,   382,   383,  -189,
     385,   381,   137,   388,  -189,  -189,  -189
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -189,   -85,  -189,  -189,  -189,  -189,  -189,   -75,  -189,  -189,
    -189,  -189,   205,  -189,  -147,  -189,  -189,  -189,  -189,  -189,
    -189,  -189,  -151,  -188,     1,    -7,  -189,    -3,  -189,   394,
    -189,   273,  -113,  -189,  -189,  -189
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -99
static const short int yytable[] =
{
      37,   109,    30,    80,    81,    82,   186,   218,    91,    92,
      79,    86,    96,   125,   250,   251,   110,   192,   211,   161,
      95,   212,   123,   102,   185,   203,   247,   202,   301,    36,
     158,   159,   103,    87,   112,   129,   174,   175,   -98,   153,
     246,    88,   206,   252,   253,   213,   254,   255,    36,    36,
     256,   257,   258,    90,    36,   259,   260,   261,   262,   263,
     107,   104,   172,   107,   130,   107,   107,   107,   154,   302,
     160,   207,    36,   211,   111,   113,   212,   233,    77,   248,
      78,   249,   191,   140,    89,   131,    93,   122,   234,    94,
     269,   142,   143,    98,   272,   132,    99,   108,   107,   114,
     243,   133,   128,   276,   277,   278,   279,   280,   281,   141,
     283,   284,   285,   115,   287,   288,   289,   116,   117,   118,
     119,   149,   120,   121,   315,     3,    30,   156,   123,   124,
       5,     6,     7,     8,   180,   298,   126,   235,   127,   299,
       3,    14,    15,    16,   134,     5,     6,     7,     8,     9,
     136,   179,   135,   137,   309,   138,    14,    15,    16,   139,
     181,     3,   144,   145,   151,   146,     5,     6,     7,     8,
       9,   132,   148,    30,   152,   181,   155,    14,   169,    38,
      39,    40,   163,   166,    41,    42,    43,    44,    45,    46,
      47,    48,    30,    49,    50,    51,    52,    53,    54,   164,
      55,    56,    57,    58,   229,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,     2,   170,   171,     3,   173,   176,     4,   177,     5,
       6,     7,     8,     9,   178,    10,    11,    12,    13,   187,
      14,    15,    16,    17,    18,    19,    20,    21,    22,     3,
     188,   189,     4,   193,     5,     6,     7,     8,     9,   194,
      10,    11,    12,    13,   197,    14,    15,    16,    17,    18,
      19,    20,    21,    22,     3,   198,   150,     4,   199,     5,
       6,     7,     8,     9,   200,    10,    11,    12,    13,   204,
      14,    15,    16,    17,    18,    19,    20,    21,    22,     3,
     205,   196,     4,   208,     5,     6,     7,     8,     9,   209,
      10,    11,    12,    13,   210,    14,    15,    16,    17,    18,
      19,    20,    21,    22,     3,   216,   215,   217,   219,     5,
       6,     7,     8,     9,   220,   100,   221,   222,     3,   224,
      14,    15,    16,     5,     6,     7,     8,     9,   225,   101,
     226,   227,   228,   231,    14,    15,    16,   230,     3,    19,
      84,   236,   237,     5,     6,     7,     8,     9,   238,   239,
     242,   240,   244,     3,    14,    15,    16,    85,     5,     6,
       7,     8,     9,   245,   265,   266,   270,   267,   268,    14,
      15,    16,   271,   273,   274,   282,   275,   286,   290,   291,
     293,   294,   307,   295,   296,   297,   223,   300,   162,   292,
     303,   308,   314,    97,   306,   311,     0,   312,   313,   316,
       0,     0,     0,   310
};

static const short int yycheck[] =
{
       3,    76,     1,     6,     7,     8,   157,   195,    15,    16,
       6,    10,    19,    98,     3,     4,     6,   168,     3,     3,
      19,     6,     3,    22,     3,     3,     3,   178,     3,    44,
       3,     4,     3,    44,     6,     3,   149,   150,    33,     3,
     228,    32,     3,    32,    33,    30,    35,    36,    44,    44,
      39,    40,    41,     3,    44,    44,    45,    46,    47,    48,
      44,    32,   147,    44,    32,    44,    44,    44,    32,    44,
      43,    32,    44,     3,    77,    78,     6,    34,     9,   230,
      11,   232,   167,     3,    32,    32,     3,    94,    45,    32,
     241,    31,    32,    29,   245,    42,    11,     7,    44,     3,
      30,   104,   101,   250,   251,   252,   253,   254,   255,    29,
     257,   258,   259,     3,   261,   262,   263,     3,     3,     3,
      44,   124,     3,    29,   312,     3,   125,   130,     3,    32,
       8,     9,    10,    11,    12,   282,    44,   212,     5,   286,
       3,    19,    20,    21,    31,     8,     9,    10,    11,    12,
       3,   154,    34,     3,   305,     7,    19,    20,    21,    29,
      38,     3,    31,     3,     3,    33,     8,     9,    10,    11,
      12,    42,    34,   172,     3,    38,    32,    19,     6,     3,
       4,     5,     7,    31,     8,     9,    10,    11,    12,    13,
      14,    15,   191,    17,    18,    19,    20,    21,    22,     7,
      24,    25,    26,    27,   207,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,     0,    33,    32,     3,     3,    32,     6,    29,     8,
       9,    10,    11,    12,    32,    14,    15,    16,    17,    43,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     3,
      43,    33,     6,    18,     8,     9,    10,    11,    12,    31,
      14,    15,    16,    17,    33,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     3,    33,    30,     6,    31,     8,
       9,    10,    11,    12,     9,    14,    15,    16,    17,    38,
      19,    20,    21,    22,    23,    24,    25,    26,    27,     3,
      33,    30,     6,    33,     8,     9,    10,    11,    12,    33,
      14,    15,    16,    17,    32,    19,    20,    21,    22,    23,
      24,    25,    26,    27,     3,    33,    30,     3,    31,     8,
       9,    10,    11,    12,    31,    14,    32,     3,     3,    33,
      19,    20,    21,     8,     9,    10,    11,    12,    33,    28,
      38,    31,    34,    31,    19,    20,    21,    32,     3,    24,
       5,     3,     3,     8,     9,    10,    11,    12,    31,     7,
      34,    33,    31,     3,    19,    20,    21,    22,     8,     9,
      10,    11,    12,    32,     7,    31,    11,    31,    31,    19,
      20,    21,     3,    33,    33,    45,    33,    45,    34,    33,
      31,    33,     3,    32,    31,    31,   201,    31,   135,    44,
      31,    33,    31,    19,    42,    33,    -1,    34,    33,    31,
      -1,    -1,    -1,    43
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    50,     0,     3,     6,     8,     9,    10,    11,    12,
      14,    15,    16,    17,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    51,    52,    53,    55,    58,    64,    67,
      73,    74,    75,    77,    78,    82,    44,    76,     3,     4,
       5,     8,     9,    10,    11,    12,    13,    14,    15,    17,
      18,    19,    20,    21,    22,    24,    25,    26,    27,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    56,    57,     9,    11,     6,
      76,    76,    76,    76,     5,    22,    73,    44,    32,    32,
       3,    74,    74,     3,    32,    73,    74,    78,    29,    11,
      14,    28,    73,     3,    32,    80,    81,    44,     7,    56,
       6,    76,     6,    76,     3,     3,     3,     3,     3,    44,
       3,    29,    74,     3,    32,    50,    44,     5,    73,     3,
      32,    32,    42,    76,    31,    34,     3,     3,     7,    29,
       3,    29,    31,    32,    31,     3,    33,    84,    34,    76,
      30,     3,     3,     3,    32,    32,    76,    65,     3,     4,
      43,     3,    80,     7,     7,    59,    31,    83,    54,     6,
      33,    32,    50,     3,    81,    81,    32,    29,    32,    76,
      12,    38,    71,    72,    73,     3,    71,    43,    43,    33,
      61,    50,    71,    18,    31,    68,    30,    33,    33,    31,
       9,    60,    71,     3,    38,    33,     3,    32,    33,    33,
      32,     3,     6,    30,    62,    30,    33,     3,    72,    31,
      31,    32,     3,    61,    33,    33,    38,    31,    34,    76,
      32,    31,    66,    34,    45,    56,     3,     3,    31,     7,
      33,    79,    34,    30,    31,    32,    72,     3,    71,    71,
       3,     4,    32,    33,    35,    36,    39,    40,    41,    44,
      45,    46,    47,    48,    63,     7,    31,    31,    31,    71,
      11,     3,    71,    33,    33,    33,    63,    63,    63,    63,
      63,    63,    45,    63,    63,    63,    45,    63,    63,    63,
      34,    33,    44,    31,    33,    32,    31,    31,    63,    63,
      31,     3,    44,    31,    69,    70,    42,     3,    33,    71,
      43,    33,    34,    33,    31,    72,    31
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value, Location);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yytype, yyvaluep, yylocationp)
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  YYLTYPE *yylerrsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
	YYSTACK_RELOCATE (yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
  *++yylsp = yylloc;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, yylsp - yylen, yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 15:
#line 77 "listgen.y"
    {faketype_add(yyvsp[-1].str, yyvsp[-2].str);;}
    break;

  case 16:
#line 78 "listgen.y"
    { curr_params = NULL; ;}
    break;

  case 18:
#line 82 "listgen.y"
    { faketype_add(yyvsp[-2].str, yyvsp[-4].str); ;}
    break;

  case 58:
#line 131 "listgen.y"
    { verbprintf(1, "FOUND: enum %s {\n", yyvsp[-1].str); enum_create(yyvsp[-1].str); ;}
    break;

  case 59:
#line 132 "listgen.y"
    { verbprintf(1, " } -> %s\n", yyvsp[-1].str); enum_close(); ;}
    break;

  case 60:
#line 133 "listgen.y"
    { verbprintf(1, "FOUND: enum %s {\n", yyvsp[-2].str); enum_nowrap = 1;;}
    break;

  case 61:
#line 134 "listgen.y"
    { verbprintf(1, " } -> %s\n", yyvsp[-1].str); enum_nowrap = 0;;}
    break;

  case 62:
#line 139 "listgen.y"
    {;}
    break;

  case 63:
#line 140 "listgen.y"
    { enum_add_element(yyvsp[0].str); ;}
    break;

  case 64:
#line 144 "listgen.y"
    { verbprintf(2, "    %s, \n", yyvsp[-1].str); yyval.str = yyvsp[-1].str;;}
    break;

  case 65:
#line 145 "listgen.y"
    { verbprintf(2, "    %s = expr, \n", yyvsp[-3].str); yyval.str = yyvsp[-3].str ;}
    break;

  case 66:
#line 146 "listgen.y"
    { yyval.str = NULL; ;}
    break;

  case 82:
#line 168 "listgen.y"
    { 
																															verbprintf(1, "FOUND: function %s:%s; params: ", yyvsp[-1].str, yyvsp[-2].str);
																															func_add(yyvsp[-2].str, yyvsp[-1].str);
																														;}
    break;

  case 83:
#line 172 "listgen.y"
    { verbprintf(1, "\n"); ;}
    break;

  case 84:
#line 174 "listgen.y"
    { 
																															verbprintf(1, "FOUND: function (* %s):%s; params: ", yyvsp[-2].str, yyvsp[-5].str);
																															func_add(yyvsp[-5].str, yyvsp[-2].str);
																														;}
    break;

  case 85:
#line 178 "listgen.y"
    { verbprintf(1, "\n"); ;}
    break;

  case 86:
#line 180 "listgen.y"
    { func_add_direct(yyvsp[-10].str); ;}
    break;

  case 87:
#line 181 "listgen.y"
    { func_add_direct(yyvsp[-11].str); ;}
    break;

  case 88:
#line 182 "listgen.y"
    { /* Don't generate wrapper for this */ curr_params = NULL;;}
    break;

  case 89:
#line 183 "listgen.y"
    { /* Don't generate wrapper for this */ curr_params = NULL;;}
    break;

  case 90:
#line 184 "listgen.y"
    { /* Don't generate wrapper for this */ curr_params = NULL;;}
    break;

  case 91:
#line 185 "listgen.y"
    { /* Don't generate wrapper for this */ curr_params = NULL;;}
    break;

  case 92:
#line 190 "listgen.y"
    { verbprintf(1, "FOUND: event %s; params: ", yyvsp[-2].str); event_add(yyvsp[-2].str); ;}
    break;

  case 93:
#line 191 "listgen.y"
    { verbprintf(1, "\n"); ;}
    break;

  case 94:
#line 195 "listgen.y"
    {curr_params_push(); curr_params = NULL; ;}
    break;

  case 95:
#line 195 "listgen.y"
    {curr_params_pop();;}
    break;

  case 99:
#line 205 "listgen.y"
    { verbprintf(2, "%s:%s ", yyvsp[0].str, yyvsp[-1].str); param_add(yyvsp[-1].str, yyvsp[0].str); ;}
    break;

  case 100:
#line 206 "listgen.y"
    { verbprintf(2, "%s:%s ", yyvsp[-2].str, yyvsp[-3].str); param_add(yyvsp[-3].str, yyvsp[-2].str); ;}
    break;

  case 101:
#line 207 "listgen.y"
    { verbprintf(2, "... "); ;}
    break;

  case 102:
#line 208 "listgen.y"
    { verbprintf(2, "%s:void* ", yyvsp[-4].str); param_add(strdup("void*"), yyvsp[-4].str); ;}
    break;

  case 103:
#line 209 "listgen.y"
    { verbprintf(2, "%s:void* ", yyvsp[-6].str); param_add(strdup("void*"), yyvsp[-6].str); ;}
    break;

  case 104:
#line 214 "listgen.y"
    { yyval.str = chr_insert(yyvsp[0].str, '!'); ;}
    break;

  case 105:
#line 215 "listgen.y"
    { yyval.str = chr_insert(yyvsp[0].str, '^'); ;}
    break;

  case 106:
#line 216 "listgen.y"
    { yyval.str = yyvsp[0].str; ;}
    break;

  case 107:
#line 221 "listgen.y"
    { yyval.str = malloc(128); strcpy(yyval.str, yyvsp[0].str); ;}
    break;

  case 108:
#line 222 "listgen.y"
    { yyval.str = malloc(128); sprintf(yyval.str, "int/%s", yyvsp[-1].str); ;}
    break;

  case 109:
#line 223 "listgen.y"
    { yyval.str = malloc(128); sprintf(yyval.str, "uint/%s", yyvsp[-1].str); ;}
    break;

  case 110:
#line 224 "listgen.y"
    { yyval.str = malloc(128); sprintf(yyval.str, "uchar/%s", yyvsp[-1].str); ;}
    break;

  case 111:
#line 225 "listgen.y"
    { check_kw(yyvsp[0].str); yyval.str = malloc(128); sprintf(yyval.str, "%s", yyvsp[0].str); ;}
    break;

  case 112:
#line 226 "listgen.y"
    { check_kw(yyvsp[-1].str); yyval.str = malloc(128); sprintf(yyval.str, "%s", yyvsp[-1].str); ;}
    break;

  case 113:
#line 227 "listgen.y"
    { check_kw(yyvsp[0].str); yyval.str = malloc(128); sprintf(yyval.str, "@%s", yyvsp[0].str); ;}
    break;

  case 114:
#line 231 "listgen.y"
    { yyval.str = "int"; ;}
    break;

  case 115:
#line 232 "listgen.y"
    { yyval.str = "int*"; ;}
    break;

  case 116:
#line 233 "listgen.y"
    { yyval.str = "uint"; ;}
    break;

  case 117:
#line 234 "listgen.y"
    { yyval.str = "uint*"; ;}
    break;

  case 118:
#line 235 "listgen.y"
    { yyval.str = "double"; ;}
    break;

  case 119:
#line 236 "listgen.y"
    { yyval.str = "double*"; ;}
    break;

  case 120:
#line 237 "listgen.y"
    { yyval.str = "char"; ;}
    break;

  case 121:
#line 238 "listgen.y"
    { yyval.str = "char*"; ;}
    break;

  case 122:
#line 239 "listgen.y"
    { yyval.str = "uchar"; ;}
    break;

  case 123:
#line 240 "listgen.y"
    { yyval.str = "uchar*"; ;}
    break;

  case 124:
#line 241 "listgen.y"
    { yyval.str = "void"; ;}
    break;

  case 125:
#line 242 "listgen.y"
    { yyval.str = "void*"; ;}
    break;

  case 128:
#line 252 "listgen.y"
    { verbprintf(1, "FOUND: keyword definition %s of %s\n", yyvsp[-5].str, yyvsp[-1].str); keyword_add(yyvsp[-5].str, kw_type_export, yyvsp[-1].str); ;}
    break;

  case 129:
#line 253 "listgen.y"
    { verbprintf(1, "FOUND: keyword definition (local) %s\n", yyvsp[-2].str); keyword_add(yyvsp[-2].str, kw_type_export, NULL);;}
    break;

  case 132:
#line 261 "listgen.y"
    {curr_params = NULL;;}
    break;

  case 140:
#line 277 "listgen.y"
    {in_struct = 1;;}
    break;

  case 141:
#line 277 "listgen.y"
    {in_struct = 0;;}
    break;

  case 142:
#line 278 "listgen.y"
    {in_struct = 1;;}
    break;

  case 143:
#line 278 "listgen.y"
    {in_struct = 0;;}
    break;


    }

/* Line 1010 of yacc.c.  */
#line 1673 "listgen.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;
  yylsp -= yylen;

  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }

  yylerrsp = yylsp;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp, yylsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	  *++yylerrsp = yylloc;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  yylerrsp = yylsp;
  *++yylerrsp = yyloc;
  yylsp -= yylen;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
  YYLLOC_DEFAULT (yyloc, yylsp, yylerrsp - yylsp);
  *++yylsp = yyloc;

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}



