#!/bin/sh
# Head replacement. I'm not sure head presents on every system, and we
# need awk for sure. It's a fallback script that emulates head using awk.
# It's a limited version, emulates only -n.


awk -v "opt=$*" '
	BEGIN {
		NUM=0;
		fn="";
		v=split(opt, A, "[ 	]");
		for(n=1; n<=v; n++) {
			if (A[n]=="-n") {
				n++
				NUM=A[n]
			}
			else {
				fn=A[n]
			}
		}
		if (fn!="") {
			for(m=0; (getline < fn)!=0; m++) {
				if (m>=NUM)
					exit
				print $0
			}
			exit
		}
	}
	{
		if ((NUM==0) || (NR<=NUM))
			print $0
	}
'
