#!/bin/sh

if test -z "$with_cc"
then
	if ! test -z "$with_target_dir"
	then
		with_cc="${with_target}gcc"
	fi
fi

if test -z "$with_ld"
then
	with_ld="${with_target}ld"
fi

if test -z "$with_strip"
then
	with_strip="${with_target}strip"
fi

if test -z "$with_sys_cflags"
then
	with_sys_cflags="-DUNIX"
fi

if test -z "$with_sys_ldl"
then
	with_sys_ldl="-ldl"
fi

if test -z "$with_sys_fpic"
then
	with_sys_fpic="-fPIC"
fi

if test -z "$with_sys_ldflags_static"
then
	with_sys_ldflags_static="-static -shared"
fi

if test -z "$with_sys_ldflags_dynamic"
then
	with_sys_ldflags_dynamic="-dynamic -shared"
fi

if test -z "$with_sys_libext_static"
then
	with_sys_libext_static=".a"
fi

if test -z "$with_sys_libext_dynamic"
then
	with_sys_libext_dynamic=".so"
fi

if test -z "$with_sys_archive_objs"
then
	with_sys_archive_objs="-Wl,-whole-archive \$(ARCHIVES) -Wl,-no-whole-archive"
fi

if test -z "$with_sys_rdynamic"
then
	with_sys_rdynamic="-rdynamic"
fi

if test -z "$with_sys_lpthread"
then
	export with_sys_lpthread="-lpthread"
fi
