#include <gpmi.h>

void *gpmi_hash_create(int size);
void gpmi_hash_store(void *table, char *key, char *data);
char *gpmi_hash_find(void *table, const char *key);
int gpmi_hash_stat_recno(void *table);
int gpmi_hash_stat_empty_node(void *table);
double gpmi_hash_stat_avg_node(void *table);
int gpmi_hash_stat_max_node(void *table);
int gpmi_hash_stat_mem(void *table);
void *gpmi_hash_rehash(void *table, int new_size);

void *hash_cursor_new(void *h);
void *hash_cursor_next(void *curs);
void *hash_cursor_key(void *curs);
void *hash_cursor_data(void *curs);
void hash_cursor_data_write(void *curs, void *new_data);
void hash_cursor_destroy(void *curs);
void *hash_cursor_rewind(void *curs);
