#include "gpmi.h"

typedef enum empty_e {
} emtpy_t;

nowrap inline void very_fast();

FAKETYPE(int, foo);
typedef uint foobar;

#define ignore_me(this) this macro will be ignored

#define multi_ignore(wow) this \
                          is a multiline \
													macro to be ignored 
//this is a //comment

int ******array[243];

/* These will be ignored - external stuff are out of scope */
extern uint alien;
extern int (*ext_function_1)(int a, char *b);
extern int *(*ext_function_2)(int a, char *b);
extern int (*ext_function_1a[4])(int a, char *b);
extern int *(*ext_function_2a[5])(int a, char *b);

/* Functions. Dynamyc means the "^" prefix */
int Example_int(int offset);
dynamic char *Example_string(int num, char *text);
int Example_do_nothing(int param);
unsigned int Example_uint(unsigned int offset);

/* Direct function: already has a string interface, no need for wrapping */
direct char *direct_func1(int argc, char **argv);
direct char *direct_func2(int argc, char *argv[]);

/* This how we define an event. It will become an int, however, this way
   listgen knows how to generate the event block in the list. */
gpmi_define_event(Example_nothing)(int developement_year, int parameter);

/* The enum version for C; have to typedef it! */
typedef enum example_colors {
	example_red			=	0x01,
	example_green		=	2, /* this is a comment */
	example_blue		=	4 + 2,
	example_shift   = (1 << 2 | 4) && (3 == 3),
} example_colors;

typedef struct unknown_t {
	foo data1; /* so nice to have a meaningless comment here */
	int data2;
} unknown_t ;

/* Defining a keyword. Note that "of example_colors" is optional (yet?) */
gpmi_keyword *Example_colors_kw; /*of example_colors*/

/** * const */

example_colors Example_color_rot(example_colors color);

/* Word "multip1e" means multiple keywords are expected ("@" prefix) */
multiple example_colors Example_color_inv(multiple example_colors color);

foo bar(foo blobb1, foobar blobb2);

void void_func(void);

void vararg_func(int last_arg, ...);

/* This struct has an union inside! */
typedef struct sock_opt_t {
	int name;
	union {
		int i;
		char *s;
		void *d;
	} value;
} sock_opt_t;

/* Wrapper is not generated for these functions because the nowrap prefix */
nowrap int hideous_func1(void *par1, void *par2);
nowrap int hideous_func2(void (*callback)(int a, int b), int num);

unsigned char uchar_fund(unsigned char uc, char c);

typedef int fake_int;
fake_int return_fake_int(fake_int in);
typedef void* fake_ptr;
fake_ptr return_fake_ptr(fake_ptr in);
